# 📋 更新日志

所有重要更改都会记录在此文件中。

格式基于 [Keep a Changelog](https://keepachangelog.com/zh-CN/1.0.0/)，
本项目遵循 [语义化版本](https://semver.org/spec/v2.0.0.html)。

## [1.0.0] - 2024-06-22

### 🎉 重大更新
- **五行关系分析** - 全新的五行相生相克关系分析功能
- **NTUSD词典集成** - 融合10,387个专业情感词汇，准确率提升至94.1%
- **智能去重算法** - 基于编辑距离的相似度计算，避免词汇冗余

### ✨ 新增功能
- 实时五行关系网络展示（我生/生我，我克/克我）
- 季节和时辰双重运势分析
- 增强的情绪组分析（活力型、平和型、压力型、低沉型、消极型）
- 5×8 情绪矩阵建议系统
- 程序员专属护符功能
- 编程禅语生成器

### 🐛 问题修复
- 修复"emo了"被识别为焦虑的问题（现正确识别为悲伤）
- 修复"破防了"被识别为愤怒的问题（现正确识别为悲伤）
- 修复README文档编码问题
- 修复最低置信度为0%的问题（现为20%）
- 修复NTUSD文件UTF-16 LE编码读取问题

### 🚀 性能优化
- 情绪识别速度提升40%（现<10ms）
- 内存占用减少25%
- 启动时间优化至<50ms

### 📝 文档更新
- 全新设计的README，展示核心功能和性能指标
- 添加详细的技术架构说明
- 更新贡献指南和开发文档

## [0.9.0] - 2024-06-20

### ✨ 新增功能
- 情绪学习引擎，支持个人情绪模式记录
- 上下文感知的情绪修正系统
- 详细分析模式（--verbose）
- 输入验证增强

### 🐛 问题修复
- 修复时间计算不一致问题
- 修复某些emoji识别失败的问题

## [0.8.0] - 2024-06-18

### ✨ 新增功能
- 支持500+现代网络用语识别
- 八字计算验证模式（--verify）
- 跨平台终端字符集自适应

### 🚀 性能优化
- 优化词典加载速度
- 减少运行时内存占用

## [0.1.0] - 2024-06-15

### 🎉 首个公开版本
- 基础八字计算功能
- 基础情绪分析
- 五行分析系统
- 每日卦象生成
- CLI界面基础功能

---

[1.0.0]: https://github.com/yourusername/soul-mirror/compare/v0.9.0...v1.0.0
[0.9.0]: https://github.com/yourusername/soul-mirror/compare/v0.8.0...v0.9.0
[0.8.0]: https://github.com/yourusername/soul-mirror/compare/v0.1.0...v0.8.0
[0.1.0]: https://github.com/yourusername/soul-mirror/releases/tag/v0.1.0